unit Unit1;

interface


uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, ComCtrls, ToolWin, StdCtrls,ShellAPI, ExtCtrls, Buttons, Registry,
  Grids;

const
  WM_ICONTRAY = WM_USER + 100;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Close1: TMenuItem;
    lohy1: TMenuItem;
    Prida1: TMenuItem;
    Vymaza1: TMenuItem;
    Pomoc1: TMenuItem;
    Oprograme1: TMenuItem;
    Spusti1: TMenuItem;
    PopupMenu1: TPopupMenu;
    Ukza1: TMenuItem;
    Skry1: TMenuItem;
    Zatvori1: TMenuItem;
    Timer1: TTimer;
    Button1: TButton;
    StatusBar1: TStatusBar;
    Button2: TButton;
    StringGrid1: TStringGrid;
    Timer2: TTimer;
    Button4: TButton;
    BitBtn1: TBitBtn;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Ukza1Click(Sender: TObject);
    procedure Skry1Click(Sender: TObject);
    procedure Zatvori1Click(Sender: TObject);
    procedure Close1Click(Sender: TObject);
    procedure PopupMenu1Popup(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Prida1Click(Sender: TObject);
    procedure StringGrid1SelectCell(Sender: TObject; ACol, ARow: Integer;
      var CanSelect: Boolean);
    procedure Button2Click(Sender: TObject);
    procedure Vymaza1Click(Sender: TObject);
    procedure Spusti1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure Oprograme1Click(Sender: TObject);
  private
    TrayIconData: TNotifyIconData;
    procedure TrayMessage(var Msg: TMessage); message WM_ICONTRAY;
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
    { Private declarations }
  public
    riadok1: integer;
    procedure Refresh;
    { Public declarations }
  end;

var
  Form1: TForm1; noFirstTime :boolean;
  vymaz,param: string;
  spusti: string='';
  riadok: integer;
  monitor1: string;
  NameBuf: array[0..80] of Char;
  SizeBuf: LongWord;
  Buffer: Array[0..MAX_COMPUTERNAME_LENGTH+1] of Char;
  Size: DWORD;
  b: boolean=false;

implementation

uses Unit2, Unit3, Unit4, Unit5, Unit6;

{$R *.dfm}
{$R ikona.res}
{$R budik.res}



procedure TForm1.FormCreate(Sender: TObject);
var RegIniFile:TRegIniFile;
    t,t2:TextFile;
    i,p,pocet:integer;
begin

  if not FileExists('c:\pocet.dat') then begin
    AssignFile(t,'c:\pocet.dat');
    ReWrite(t);
    Write(t,0);
    CloseFile(t);
  end
  else begin
    pocet:=0;
    AssignFile(t,'c:\pocet.dat');
    Reset(t);
    Readln(t,p);
    CloseFile(t);
    for i:=1 to p do begin
      if FileExists('c:\task'+IntToStr(i)+'.dat') then
        inc(pocet);
    end;
   if pocet=0 then begin
    AssignFile(t2,'c:\pocet.dat');
    ReWrite(t2);
    Write(t2,0);
    CloseFile(t2);
   end;

  end;

  StatusBar1.Panels[0].Text:='Copyright Michal Bujdak 2007';

  SizeBuf := Sizeof(NameBuf);
  GetUserName(NameBuf, SizeBuf);
  size:=1024;
  Windows.GetComputerName(Buffer, Size);

  StatusBar1.Panels[2].Text:='Prihlsen: '+NameBuf+' na '+StrPas(Buffer);

  Application.Icon.Handle:=LoadIcon(HInstance,'IKONA');
  Application.Title:='Planovac';

  RegIniFile :=TRegIniFile.Create;
  RegIniFile.RootKey :=HKEY_LOCAL_MACHINE;
  RegIniFile.WriteString('SOFTWARE\Microsoft\Windows\CurrentVersion\Run'
                          ,'planovac',Application.ExeName);

  Refresh;

  SetWindowLong(Application.Handle, GWL_EXSTYLE, WS_EX_TOOLWINDOW);

  with TrayIconData do
  begin
    cbSize := SizeOf(TrayIconData);
    Wnd := Handle;
    uID := 0;
    uFlags := NIF_MESSAGE + NIF_ICON + NIF_TIP;
    uCallbackMessage := WM_ICONTRAY;
    hIcon := Application.Icon.Handle;
    StrPCopy(szTip, Application.Title);
  end;

  Shell_NotifyIcon(NIM_ADD, @TrayIconData);
end;

procedure TForm1.TrayMessage(var Msg: TMessage);
var
  p: TPoint;
begin
  case Msg.lParam of
    WM_LBUTTONDBLCLK:
      begin
        WindowState := wsNormal;
        SetForegroundWindow(handle);
        with Screen do
          DrawAnimatedRects(Handle,
                   3,
                   Rect(Width-20, Height, Width-10, Height),
                   BoundsRect);
        Show;
      end;
    WM_RBUTTONDOWN:
      begin
 	  SetForegroundWindow(Handle);
        GetCursorPos(p);
        PopUpMenu1.Popup(p.x, p.y);
        PostMessage(Handle, WM_NULL, 0, 0);
      end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  Shell_NotifyIcon(NIM_DELETE, @TrayIconData);
end;

procedure TForm1.Ukza1Click(Sender: TObject);
begin
  WindowState := wsNormal;
  SetForegroundWindow(handle);
  with Screen do
    DrawAnimatedRects(Handle,
                   3,
                   Rect(Width-20, Height, Width-10, Height),
                   BoundsRect);
  Show;
end;

procedure TForm1.Skry1Click(Sender: TObject);
begin
  Hide;
end;

procedure TForm1.Zatvori1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.Close1Click(Sender: TObject);
begin
  Close;
end;

procedure TForm1.PopupMenu1Popup(Sender: TObject);
begin
  Ukza1.Enabled := not Visible;
  Skry1.Enabled := Visible;
end;

procedure TForm1.WMSysCommand(var Msg: TWMSysCommand);
begin
  if (Msg.CmdType = SC_MINIMIZE) or
    (Msg.CmdType = SC_CLOSE) then
  begin
    Hide;
    exit;
  end
  else if (Msg.CmdType = SC_MAXIMIZE) then
   MessageBeep(0) else
    DefaultHandler(Msg);
end;

procedure TForm1.FormShow(Sender: TObject);
var ToBeHidden: boolean;
begin
  if  noFirstTime then exit;
  noFirstTime := true;
  ToBeHidden := true;
  if ToBeHidden then
  begin
    WindowState := wsMinimized;
    Timer1.Enabled := True;
  end;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  (Sender as TTimer).Enabled := False;
  Hide;
  WindowState := wsNormal;

end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.Prida1Click(Sender: TObject);
begin
  Form2.Show;
end;

procedure TForm1.StringGrid1SelectCell(Sender: TObject; ACol,
  ARow: Integer; var CanSelect: Boolean);
begin
   vymaz:=StringGrid1.Cells[6,ARow];
   spusti:=StringGrid1.Cells[4,ARow];
   param:=StringGrid1.Cells[5,ARow];
   riadok:=ARow;
   monitor1:=StringGrid1.Cells[0,ARow];
end;

procedure TForm1.Button2Click(Sender: TObject);
var t:TextFile;
begin
  AssignFile(t,'c:\'+vymaz);
  if FileExists('c:\'+vymaz) then
  Erase(t);
  Refresh;
end;

procedure TForm1.Refresh;
var
    t,t1:TextFile;
    pocet,i,j,k,m:integer;
    s:string;
    meno,miesto,parametre,datum,frekvencia,cas:string;
    a:array[1..5] of integer;
begin
  StringGrid1.Cols[0].Text:='Meno lohy';
  StringGrid1.Cols[1].Text:='Frekvencia';
  StringGrid1.Cols[2].Text:='Dtum';
  StringGrid1.Cols[3].Text:='Cas';
  StringGrid1.Cols[4].Text:='Umiestnenie';
  StringGrid1.Cols[5].Text:='Parametre';
  StringGrid1.Cols[6].Text:='ID';
  AssignFile(t,'c:\pocet.dat');
  Reset(t);
  Read(t,pocet);
  CloseFile(t);
  m:=1;
  for i:=1 to pocet do begin
    k:=1;
    if FileExists('c:\task'+IntToStr(i)+'.dat') then begin
    AssignFile(t1,'c:\task'+IntToStr(i)+'.dat');
    Reset(t1);
    Read(t1,s);
    CloseFile(t1);
    for j:=1 to Length(s) do begin
      if s[j]='#' then begin
        a[k]:=j;
        inc(k);
      end;
    end;

    meno:=Copy(s,1,a[1]-1);
    frekvencia:=Copy(s,a[1]+1,a[2]-a[1]-1);
    datum:=Copy(s,a[2]+1,a[3]-a[2]-1);
    cas:=Copy(s,a[3]+1,a[4]-a[3]-1);
    miesto:=Copy(s,a[4]+1,a[5]-a[4]-1);
    parametre:=Copy(s,a[5]+1,Length(s)-a[5]);

    StringGrid1.Cells[0,m]:=meno;
    StringGrid1.Cells[1,m]:=frekvencia;
    StringGrid1.Cells[2,m]:=datum;
    StringGrid1.Cells[3,m]:=cas;
    StringGrid1.Cells[4,m]:=miesto;
    StringGrid1.Cells[5,m]:=parametre;
    StringGrid1.Cells[6,m]:='task'+IntToStr(i)+'.dat';

    inc(m);
    end;
  end;
end;

procedure TForm1.Vymaza1Click(Sender: TObject);
begin
  Button2Click(Sender);
end;

procedure TForm1.Spusti1Click(Sender: TObject);
begin
  if spusti<>'' then
    ShellExecute(Handle,nil,Pchar(spusti),PChar(param),nil,SW_SHOW);
  if StringGrid1.Cells[0,riadok]='Pripomienka' then begin
    riadok1:=riadok;
    Form4.Show;
  end;
  if StringGrid1.Cells[0,riadok]='Budik' then begin
    Form5.Show;
  end;
  if StringGrid1.Cells[0,riadok]='Monitor_off' then
    SendMessage(Application.Handle, WM_SYSCOMMAND, SC_MONITORPOWER, 2);
  if StringGrid1.Cells[0,riadok]='ScreenSaver' then begin
    if SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,@b,0) <> true then exit;
      if not b then exit;
        PostMessage(GetDesktopWindow, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
  end;
end;


procedure TForm1.Timer2Timer(Sender: TObject);
var t,t1:TextFile;
    pocet,i:integer;
    miesto,parametre:string;
    Po,Ut,St,Stv,Pi,So,Ne:integer;
    b:boolean;
begin
  StatusBar1.Panels[1].Text:=DateToStr(date)+ ' '+TimeToStr(time);
  Refresh;
  AssignFile(t,'c:\pocet.dat');
  Reset(t);
  Readln(t,pocet);
  CloseFile(t);
  for i:=1 to pocet do begin
    if (TimeToStr(time)=StringGrid1.Cells[3,i]) and (DateToStr(date)=StringGrid1.Cells[2,i]) and (StringGrid1.Cells[0,i]='Monitor_off') then begin
      SendMessage(Application.Handle, WM_SYSCOMMAND, SC_MONITORPOWER, 2);
      AssignFile(t1,'c:\'+StringGrid1.Cells[6,i]);
      Erase(t1);
      Refresh;
    end;
    if (TimeToStr(time)=StringGrid1.Cells[3,i]) and (DateToStr(date)=StringGrid1.Cells[2,i]) and (StringGrid1.Cells[0,i]='ScreenSaver') then begin
      if SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,@b,0) <> true then exit;
        if not b then exit;
          PostMessage(GetDesktopWindow, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
      AssignFile(t1,'c:\'+StringGrid1.Cells[6,i]);
      Erase(t1);
      Refresh;
    end;
    if (TimeToStr(time)=StringGrid1.Cells[3,i]) and (DateToStr(date)=StringGrid1.Cells[2,i]) and (StringGrid1.Cells[0,i]='Pripomienka') then begin
      riadok1:=i;
      Form4.Show;
      AssignFile(t1,'c:\'+StringGrid1.Cells[6,i]);
      Erase(t1);
      Refresh;
    end;
    if (TimeToStr(time)=StringGrid1.Cells[3,i]) and (DateToStr(date)=StringGrid1.Cells[2,i]) and (StringGrid1.Cells[0,i]='Budik') then begin
      Form5.Show;
      AssignFile(t1,'c:\'+StringGrid1.Cells[6,i]);
      Erase(t1);
      Refresh;
    end;
    if (TimeToStr(time)=StringGrid1.Cells[3,i]) and (DateToStr(date)=StringGrid1.Cells[2,i]) and (StringGrid1.Cells[1,i]='len raz') then begin
      miesto:=StringGrid1.Cells[4,i];
      parametre:=StringGrid1.Cells[5,i];
      ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
      AssignFile(t1,'c:\'+StringGrid1.Cells[6,i]);
      Erase(t1);
      Refresh;
    end;
    if (TimeToStr(time)=StringGrid1.Cells[3,i]) and (StringGrid1.Cells[1,i]='denne') then begin
      miesto:=StringGrid1.Cells[4,i];
      parametre:=StringGrid1.Cells[5,i];
      ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
    end;
     if (TimeToStr(time)=StringGrid1.Cells[3,i]) and (StringGrid1.Cells[1,i]<>'denne') and (StringGrid1.Cells[1,i]<>'len raz') then begin
        Po:=Pos('Pon',StringGrid1.Cells[1,i]);
        Ut:=Pos('Uto',StringGrid1.Cells[1,i]);
        St:=Pos('Str',StringGrid1.Cells[1,i]);
        Stv:=Pos('Stv',StringGrid1.Cells[1,i]);
        Pi:=Pos('Pia',StringGrid1.Cells[1,i]);
        So:=Pos('Sob',StringGrid1.Cells[1,i]);
        Ne:=Pos('Ned',StringGrid1.Cells[1,i]);
       if (Po<>0) and (IntToStr(Integer(DayOfWeek(date)))='2') then begin
         miesto:=StringGrid1.Cells[4,i];
         parametre:=StringGrid1.Cells[5,i];
         ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
       end;
       if (Ut<>0) and (IntToStr(Integer(DayOfWeek(date)))='3') then begin
         miesto:=StringGrid1.Cells[4,i];
         parametre:=StringGrid1.Cells[5,i];
         ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
       end;
       if (St<>0) and (IntToStr(Integer(DayOfWeek(date)))='4') then begin
         miesto:=StringGrid1.Cells[4,i];
         parametre:=StringGrid1.Cells[5,i];
         ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
       end;
       if (Stv<>0) and (IntToStr(Integer(DayOfWeek(date)))='5') then begin
         miesto:=StringGrid1.Cells[4,i];
         parametre:=StringGrid1.Cells[5,i];
         ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
       end;
       if (Pi<>0) and (IntToStr(Integer(DayOfWeek(date)))='6') then begin
         miesto:=StringGrid1.Cells[4,i];
         parametre:=StringGrid1.Cells[5,i];
         ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
       end;
       if (So<>0) and (IntToStr(Integer(DayOfWeek(date)))='7') then begin
         miesto:=StringGrid1.Cells[4,i];
         parametre:=StringGrid1.Cells[5,i];
         ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
       end;
       if (Ne<>0) and (IntToStr(Integer(DayOfWeek(date)))='1') then begin
         miesto:=StringGrid1.Cells[4,i];
         parametre:=StringGrid1.Cells[5,i];
         ShellExecute(Handle,nil,PChar(miesto),PChar(parametre),nil,SW_SHOW);
       end;
     end;
  end;

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
  if spusti<>'' then
    ShellExecute(Handle,nil,Pchar(spusti),PChar(param),nil,SW_SHOW);
  if StringGrid1.Cells[0,riadok]='Pripomienka' then begin
    riadok1:=riadok;
    Form4.Show;
  end;
  if StringGrid1.Cells[0,riadok]='Budik' then begin
    Form5.Show;
  end;
  if StringGrid1.Cells[0,riadok]='Monitor_off' then
    SendMessage(Application.Handle, WM_SYSCOMMAND, SC_MONITORPOWER, 2);
  if StringGrid1.Cells[0,riadok]='ScreenSaver' then begin
    if SystemParametersInfo(SPI_GETSCREENSAVEACTIVE,0,@b,0) <> true then exit;
      if not b then exit;
        PostMessage(GetDesktopWindow, WM_SYSCOMMAND, SC_SCREENSAVE, 0);
  end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
  Form3.Show;
end;

procedure TForm1.Oprograme1Click(Sender: TObject);
begin
  Form6.Show;
end;

end.



