unit Unit2;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, StdCtrls, ExtCtrls, Buttons, unit1;

type
  TForm2 = class(TForm)
    OpenDialog1: TOpenDialog;
    Label1: TLabel;
    Edit1: TEdit;
    Label2: TLabel;
    Edit2: TEdit;
    Label3: TLabel;
    Edit3: TEdit;
    BitBtn1: TBitBtn;
    Panel1: TPanel;
    Panel2: TPanel;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    CheckBox1: TCheckBox;
    CheckBox2: TCheckBox;
    CheckBox3: TCheckBox;
    CheckBox4: TCheckBox;
    CheckBox5: TCheckBox;
    CheckBox6: TCheckBox;
    CheckBox7: TCheckBox;
    ComboBox1: TComboBox;
    MonthCalendar1: TMonthCalendar;
    Button1: TButton;
    Button2: TButton;
    Edit4: TEdit;
    Label4: TLabel;
    procedure BitBtn1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1DropDown(Sender: TObject);
    procedure MonthCalendar1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OpenDialog1CanClose(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure CheckBox2Click(Sender: TObject);
    procedure CheckBox3Click(Sender: TObject);
    procedure CheckBox4Click(Sender: TObject);
    procedure CheckBox5Click(Sender: TObject);
    procedure CheckBox6Click(Sender: TObject);
    procedure CheckBox7Click(Sender: TObject);
    procedure RadioButton1Click(Sender: TObject);
    procedure RadioButton2Click(Sender: TObject);
    procedure RadioButton3Click(Sender: TObject);
    procedure MonthCalendar1DblClick(Sender: TObject);
  private
    procedure WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form2: TForm2;

implementation


{$R *.dfm}

procedure TForm2.BitBtn1Click(Sender: TObject);
begin
  OpenDialog1.Execute;
end;

procedure TForm2.FormCreate(Sender: TObject);
begin
  ComboBox1.Text:=DatetoStr(Date);
  MonthCalendar1.Date:=Date;
  Edit4.Text:=TimeToStr(Time);
end;

procedure TForm2.WMSysCommand(var Msg: TWMSysCommand);
begin
 if (Msg.CmdType = SC_MAXIMIZE) then
   MessageBeep(0) else
    DefaultHandler(Msg);
end;

procedure TForm2.ComboBox1DropDown(Sender: TObject);
begin
  MonthCalendar1.Visible:=true;
  MonthCalendar1.SetFocus;
  MonthCalendar1.Show;
end;

procedure TForm2.MonthCalendar1Click(Sender: TObject);
begin
  RadioButton1.Checked:=true;
  ComboBox1.Text:=DateToStr(MonthCalendar1.Date);
end;

procedure TForm2.Button2Click(Sender: TObject);
begin
  Form2.Close;
  Edit1.Clear;
  Edit2.Clear;
  Edit3.Clear;
  MonthCalendar1.Hide;
  CheckBox1.Checked:=false;
  CheckBox2.Checked:=false;
  CheckBox3.Checked:=false;
  CheckBox4.Checked:=false;
  CheckBox5.Checked:=false;
  CheckBox6.Checked:=false;
  CheckBox7.Checked:=false;
  RadioButton1.Checked:=true;
end;

procedure TForm2.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  ComboBox1.Text:=DateToStr(Date);
end;

procedure TForm2.OpenDialog1CanClose(Sender: TObject;
  var CanClose: Boolean);
begin
    Edit2.Text:=OpenDialog1.FileName;
end;

procedure TForm2.Button1Click(Sender: TObject);
var
  meno,miesto,parametre,datum,frekvencia,cas,a:string;
  t,t1:TextFile;
  pocet:integer;
begin
//////////////////////////////////
  AssignFile(t,'c:\pocet.dat');
  Reset(t);
  Readln(t,pocet);
  CloseFile(t);
  pocet:=pocet+1;                //pocet uloh
  ReWrite(t);
  Write(t,pocet);
  CloseFile(t);
//////////////////////////////////

  meno:=Edit1.Text;
  miesto:=Edit2.Text;
  parametre:=Edit3.Text;
  datum:=ComboBox1.Text;
  cas:=Edit4.Text;
  if CheckBox1.Checked then
    frekvencia:=frekvencia+'Pon+';
  if CheckBox2.Checked then
    frekvencia:=frekvencia+'Uto+';
  if CheckBox3.Checked then
    frekvencia:=frekvencia+'Str+';
  if CheckBox4.Checked then                 //zapis ulohy
    frekvencia:=frekvencia+'Stv+';
  if CheckBox5.Checked then
    frekvencia:=frekvencia+'Pia+';
  if CheckBox6.Checked then
    frekvencia:=frekvencia+'Sob+';
  if CheckBox7.Checked then
    frekvencia:=frekvencia+'Ned';
  if RadioButton2.Checked then
    frekvencia:=frekvencia+'denne';
  if frekvencia='' then
    frekvencia:=frekvencia+'len raz';

  AssignFile(t1,'c:\task'+IntToStr(pocet)+'.dat');
  ReWrite(t1);
  Write(t1,meno+'#'+frekvencia+'#'+datum+'#'+cas+'#'+miesto+'#'+parametre);
  CloseFile(t1);



///////////////////////////////

  Form2.Close;
  Edit1.Clear;
  Edit2.Clear;
  Edit3.Clear;
  MonthCalendar1.Hide;
  CheckBox1.Checked:=false;
  CheckBox2.Checked:=false;         //zaznam ulozeny, koniec
  CheckBox3.Checked:=false;
  CheckBox4.Checked:=false;
  CheckBox5.Checked:=false;
  CheckBox6.Checked:=false;
  CheckBox7.Checked:=false;
  RadioButton1.Checked:=true;

////////////////////////////////////

end;

procedure TForm2.CheckBox1Click(Sender: TObject);
begin
  if CheckBox1.Checked then
    RadioButton3.Checked:=true;
end;

procedure TForm2.CheckBox2Click(Sender: TObject);
begin
  if CheckBox2.Checked then
    RadioButton3.Checked:=true;
end;

procedure TForm2.CheckBox3Click(Sender: TObject);
begin
  if CheckBox3.Checked then
    RadioButton3.Checked:=true;
end;

procedure TForm2.CheckBox4Click(Sender: TObject);
begin
  if CheckBox4.Checked then
    RadioButton3.Checked:=true;
end;

procedure TForm2.CheckBox5Click(Sender: TObject);
begin
  if CheckBox5.Checked then
    RadioButton3.Checked:=true;
end;

procedure TForm2.CheckBox6Click(Sender: TObject);
begin
  if CheckBox6.Checked then
    RadioButton3.Checked:=true;
end;

procedure TForm2.CheckBox7Click(Sender: TObject);
begin
  if CheckBox7.Checked then
    RadioButton3.Checked:=true;
end;

procedure TForm2.RadioButton1Click(Sender: TObject);
begin
  if RadioButton1.Checked then
    begin
      CheckBox1.Checked:=false;
      CheckBox2.Checked:=false;
      CheckBox3.Checked:=false;
      CheckBox4.Checked:=false;
      CheckBox5.Checked:=false;
      CheckBox6.Checked:=false;
      CheckBox7.Checked:=false;
      Combobox1.Text:=DateToStr(Date);
    end;
end;

procedure TForm2.RadioButton2Click(Sender: TObject);
begin
  if RadioButton2.Checked then
    begin
      CheckBox1.Checked:=false;
      CheckBox2.Checked:=false;
      CheckBox3.Checked:=false;
      CheckBox4.Checked:=false;
      CheckBox5.Checked:=false;
      CheckBox6.Checked:=false;
      CheckBox7.Checked:=false;
      ComboBox1.Clear;
    end;
end;

procedure TForm2.RadioButton3Click(Sender: TObject);
begin
  if RadioButton3.Checked then
    ComboBox1.Clear;
end;

procedure TForm2.MonthCalendar1DblClick(Sender: TObject);
begin
  MonthCalendar1.Visible:=false;
end;

end.
